Package ghidra.trace.database.symbol

# Class DBTraceSymbolMultipleTypesWithLocationView<T extends AbstractDBTraceSymbol>

java.lang.Object
ghidra.trace.database.symbol.DBTraceSymbolMultipleTypesView<T>
ghidra.trace.database.symbol.DBTraceSymbolMultipleTypesWithLocationView<T>

All Implemented Interfaces:
  `TraceSymbolView<T>`, `TraceSymbolWithLocationView<T>`

public class DBTraceSymbolMultipleTypesWithLocationView<T extends AbstractDBTraceSymbol> extends DBTraceSymbolMultipleTypesView<T> implements TraceSymbolWithLocationView<T>

- ## Field Summary

  ### Fields inherited from class ghidra.trace.database.symbol.DBTraceSymbolMultipleTypesView

  `manager, parts`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DBTraceSymbolMultipleTypesWithLocationView(DBTraceSymbolManager manager, AbstractDBTraceSymbolSingleTypeWithLocationView<? extends T>... parts)`
  `DBTraceSymbolMultipleTypesWithLocationView(DBTraceSymbolManager manager, Collection<? extends AbstractDBTraceSymbolSingleTypeWithLocationView<? extends T>> parts)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Collection<? extends T>`
  `getAt(long snap, Address address, boolean includeDynamicSymbols)`
  Get symbols in this view at the given point.
  `T`
  `getChildWithNameAt(String name, long snap, Address address, TraceNamespaceSymbol parent)`
  Get the child of the given parent having the given name at the given point.
  `Collection<? extends T>`
  `getIntersecting(Lifespan span, AddressRange range, boolean includeDynamicSymbols, boolean forward)`
  Get symbols in this view intersecting the given box.
  `protected Collection<? extends AbstractDBTraceSymbolSingleTypeWithLocationView<? extends T>>`
  `getParts()`

  ### Methods inherited from class ghidra.trace.database.symbol.DBTraceSymbolMultipleTypesView

  `getAll, getChildren, getChildrenNamed, getManager, getNamed, getWithMatchingName, scanByName`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface ghidra.trace.model.symbol.TraceSymbolView

  `getAll, getChildren, getChildrenNamed, getGlobals, getGlobalsNamed, getManager, getNamed, getTrace, getWithMatchingName, scanByName, size`

  ### Methods inherited from interface ghidra.trace.model.symbol.TraceSymbolWithLocationView

  `getAt, getAt, getChildWithNameAt, getChildWithNameAt, getGlobalWithNameAt, getIntersecting, getIntersecting, hasAt`

- ## Constructor Details

  - ### DBTraceSymbolMultipleTypesWithLocationView

    public DBTraceSymbolMultipleTypesWithLocationView(DBTraceSymbolManager manager, Collection<? extends AbstractDBTraceSymbolSingleTypeWithLocationView<? extends T>> parts)

  - ### DBTraceSymbolMultipleTypesWithLocationView

    @SafeVarargs public DBTraceSymbolMultipleTypesWithLocationView(DBTraceSymbolManager manager, AbstractDBTraceSymbolSingleTypeWithLocationView<? extends T>... parts)

- ## Method Details

  - ### getParts

    protected Collection<? extends AbstractDBTraceSymbolSingleTypeWithLocationView<? extends T>> getParts()

  - ### getChildWithNameAt

    public T getChildWithNameAt(String name, long snap, Address address, TraceNamespaceSymbol parent)
    Description copied from interface: `TraceSymbolWithLocationView`
    Get the child of the given parent having the given name at the given point.
    Specified by:
      `getChildWithNameAt` in interface `TraceSymbolWithLocationView<T extends AbstractDBTraceSymbol>`
    Parameters:
      `name` - the name of the symbol
      `snap` - the snapshot key
      `address` - the address of the symbol
      `parent` - the parent namespace
    Returns:
      the symbol, or null

  - ### getAt

    public Collection<? extends T> getAt(long snap, Address address, boolean includeDynamicSymbols)
    Description copied from interface: `TraceSymbolWithLocationView`
    Get symbols in this view at the given point.

    The result will be ordered with the primary symbol first.

    Specified by:
      `getAt` in interface `TraceSymbolWithLocationView<T extends AbstractDBTraceSymbol>`
    Parameters:
      `snap` - the snapshot key
      `address` - the address of the symbols
      `includeDynamicSymbols` - true to include dynamically-generated symbols
    Returns:
      the symbols in this view satisfying the query

  - ### getIntersecting

    public Collection<? extends T> getIntersecting(Lifespan span, AddressRange range, boolean includeDynamicSymbols, boolean forward)
    Description copied from interface: `TraceSymbolWithLocationView`
    Get symbols in this view intersecting the given box.
    Specified by:
      `getIntersecting` in interface `TraceSymbolWithLocationView<T extends AbstractDBTraceSymbol>`
    Parameters:
      `span` - the time bound of the box
      `range` - the address bound of the box
      `includeDynamicSymbols` - true to include dynamically-generated symbols
      `forward` - true if the collection should be ordered forward by address, false for backward by address.
    Returns:
      the symbols in this view satisfying the query